      Program SHEEP
C     ***********
C     Subsurface Hydrology Environmental Elementary Processes
      IMPLICIT REAL*8 (A-H,O-Z)

      CHARACTER      OUTNAME*12
      LOGICAL        bool1, bool2
      DIMENSION      capwrite(100,2),xx(50),yy(50),cc(50,50)

      COMMON /PAR/   c1, THR,THS, ALPHA, GN, GM, EXPO,hzero, conds,
     *               RN, RM, gn1, gn2,w1,w2, gm1, gm2,alpha1,alpha2,
     #               film,   pfilm

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

      common /Layered/zlayer(4),  thrl(3),thsl(3),alphal(3),gnl(3),
     #                gml(3),     expol(3),condsl(3)
      common /soils/ soilp(238),flux(68)
      common /Bgrv/  Epot, bagn, avp

      EXTERNAL Randel, Vangen, Press, Simpson, Crank1, Fuente,
     # Newton, Zero2,  MFP,   Bound,   Bagrov, bmatrix
      DATA  PI/3.141592654/
C
      PRINT *,    ' Name of output file: '
      READ (*,151)  OUTNAME
  151 FORMAT(A12)
      OPEN (7, FILE=OUTNAME, STATUS='UNKNOWN')
      write (7,7003) 
 7003 format(/,5X,'ELEMENTARY PROCESSES IN SUBSURFACE HYDROLOGY')
      write (7,1001)  ! underscore
 1001 format (' ================================================')
 1002 format ('                                                 ')
 1003  format(60(1H*))

      print *,'         '
      print *,'  -----------------------------------------------------'
      print *,' Subsurface Hydrology Environmental Elementary ',
     # 'Processes '
      print *,'  -----------------------------------------------------'

    1 continue
      print *,'           '
      PRINT *,' Input of soil hydraulic parameters (MANDATORY !)  1'
      print *,' Unsaturated soil hydrology                        2'
      print *,' Groundwater hydrology                             3'
      print *,' Agricultural drainage                             4'
      print *,' Solute transport                                  5'
      PRINT *,' EXIT                                              6'
      read (*,*) k
      if (k .eq. 6) then
        print *,' exit '
        stop
      end if

      if (k .eq. 1) then
      print *,' Input of soil hydraulic parameters (VanGen./Mual.)  1'
      print *,' Standard soil parameters of texture classes         2'
      read (*,*) k1
      goto  (10,6),k1
      end if

      if (k .eq. 2) then
      PRINT *,' VAN GENUCHTEN relations of (h)                      1'
      PRINT *,' VAN GENUCHTEN relations of (theta)                  2'
      PRINT *,' Matrix flux potential between 2 reference pressures 3'
      PRINT *,' Steady-state vertical flow from or to groundwater   4'
      print *,' Drying of bare soil by evaporation                  5'
      PRINT *,' Internal drainage, bottom boundary: pressure head   6'
      PRINT *,' Unit gradient transient drainage                    7'
      PRINT *,' Infiltration (1D, 3D)                               8'
      print *,' Green and Ampt Infiltration (shallow groundwater)   9'
      read (*,*) k2
      goto (20,30,40,50,60,70,80,90,100),k2
      end if

      if (k .eq. 3) then
      print *,'       '
      print *,' Groundwater Flow: '
      print *,' Horizontal steady-state flow                1 '
      print *,' Radial symmetric  flow                      2 '
      print *,' Long-term average groundwater recharge      3 '
      read (*,*) k3
      goto (120, 130, 180), k3
      end if

      if (k .eq. 4) then
      print *,' Steady-state drainage                              1'
      print *,' Non steady-state drainage                          2'
      print *,' 2D constant flux infiltration (furrow-irrigation)  3'
      read (*,*) k4
      goto (190, 200, 110),k4
      end if

      if (k .eq. 5) then
      print *,'         '
      print *,' Solute Transport: '
      print *,' Piston flow, linear sorption,first-order-decay     1 '
      print *,' Breakthrough curve, step  input                    2 '
      print *,' Breakthrough curve, pulse input                    3 '
      print *,' 2-D transient solute transport in groundwater      4 '
      read (*,*) k5
      goto (140, 150, 160, 170), k5
      end if

C
C      ********************* Standard parameters   ******************

    6 print *,' Standard soil hydraulic parameters of german ',
     # 'texture classes, enter soil number: '

      print *,' Ss  1      Su2 8     Lt3 15    Ut3  22     Ts2  29 ' 
      print *,' Sl2 2      Su3 9     Lts 16    Ut4  23     Ts3  30 '
      print *,' Sl3 3      Su4 10    Lu  17    Tt   24     Ts4  31 '
      print *,' Sl4 4      Ls2 11    Uu  18    Tl   25     fS   32 '
      print *,' Slu 5      Ls3 12    Uls 19    Tu2  26     mS   33 '
      print *,' St2 6      Ls4 13    Us  20    Tu3  27     gS   34 '
      print *,' St3 7      Lt2 14    Ut2 21    Tu4  28 '
      print *,'  '
      read (*,*) ksoil
      if (ksoil .lt. 1 .or. ksoil .gt. 34) then
          print *,' wrong number!'
          goto 6
        end if
      mvg  =0
      kdur =0
      kfilm=0
      hzero=0.01
      i=7*(ksoil-1)+1
      thr=soilp(i+1)
      ths=soilp(i+2)
      alpha=soilp(i+3)
      gn=soilp(i+4)
      expo=soilp(i+5)
      conds=soilp(i+6)   
      gm=1.-1./gn
      rm=1./gm

      rn=1./gn
      C1=alpha**gn
      write (7,1007) ksoil
 1007 format (2X,'  Soil number: ',I2)
      goto 18

   10 M=1              ! parameter input from keyboard
      WRITE(*,1000)
 1000 FORMAT(//,' Soil hydraulic parameters,',
     *' vanGenuchten/Mualem model',/)
      write (7,1001)   ! underscore   

      print *,' Schaap/vGenuchten modification near saturation?(0,1)'
      read (*,*)mvg
C     -----     mvg=0 means van Genuchten (1980) is used.
C     -----     mvg=1 means Modified MvG Model VZJ 5(2006)27-34    

      print *,' Do you want to use bimodal porosity functions? (0,1)'
      read (*,*) kdur
      print *, ' Do you want to consider film flow? ', 
     #   '(Peters and Durner, 2008),yes,no (1,0) '
      read (*,*) kfilm
      hzero=0.01
      PRINT *,'  THETA-R, THETA-S(cm3/cm3)   '
   11 READ (*,*) thr, ths

      if (kdur .eq. 0) then
       PRINT *,   ' ALPHA (1/cm), N   '
   12  READ (*,*)   ALPHA, GN
       IF (GN .LT. 1.02) PRINT *,'  Warning: N too small !  '
       gm = 1.-1./gn
       rm = 1./gm
       rn = 1./gn
       C1=  alpha**gn
       if  (mvg .eq. 1 .and. gn .lt. 1.2) mvg=2
      else
       print *,' Bimodal Durner function, order of input: '
       print *,' w1,alpha1,gn1, w2,alpha2, gn2 '
       read (*,*)w1,alpha1,gn1,w2,alpha2, gn2
       gm1 = 1.-1./gn1
       gm2 = 1.-1./gn2
      end if 

      PRINT *,'  EXPO (tortuosity parameter, recommended:-1..0.5)'
   13 READ (*,*) EXPO

      PRINT *,'  SATURATED CONDUCTIVITY cm/d  '
      PRINT *,'  Throughout the program the time unit is assumed to be'
      PRINT *,'  days, except for infiltration time input'
   14 READ (*,*) CONDS 
C
   17 film =0.
      pfilm=1.
      if (kdur .eq. 1 .and. kfilm .eq. 1) then
        print  *, 'input film, pfilm '
        read (*,*) film,pfilm
        if (pfilm .lt. 0. .or. film .lt. 0.) then
           print *,' values > 0 expected '
           goto 17
        end if
      end if

      PRINT *,'  Data ok?  (no=0, yes=1)   '
      READ (*,*) NY
      IF ( NY .EQ. 0) GOTO 10
   18 continue
      if (kdur .eq.0) write (7,1004) thr, ths, alpha, gn, expo, conds
      if (kdur .eq.1) write (7,1005) thr, ths, w1, alpha1,gn1,  w2,
     #  alpha2, gn2, expo, conds, film, pfilm
 1004 format(/,2X,'THR,THS, ALPHA, N, EXPO, CONDS: ',/,2X,6E13.5)
 1005 format(/,2X,'Bimodal Durner function in use',  /,
     #  5X,'thr,          ths,          w1,          alpha1,       ',
     #  'gn1, ',/,
     #  5X,'w2,           alpha2,       gn2,         expo,         ',
     #  'conds, film, pfilm: ',/,3(2X,5E14.5,/))

      if (mvg .gt. 0 .or. kdur .gt. 0) goto 15   ! skip matching point
      print *,' Do you want to use a  matching point other than Ks ', 
     # 'for the prediction of hydraulic conductivity? (0,1) '
      read (*,*) ny
      if (ny .eq. 1) then
        print *,' Do not select this option for groundwater flow!'
        print *,' input of matching point conductivity (cm/d) and ',
     #  'corresponding pressure head (<0)' 
       read (*,*) condMP,hMP   ! MP = matching point
       hp=hMP
       h=-hp
       M=1
       IB=2
       call VANGEN
       condsoriginal=conds  ! as a precaution
       conds=condMP/RELK
      end if
   15 continue
      GOTO 1

C     *****************   MENUE vanGenuchten/Mualem   ***********
   20 M=2
      IB=2
      WRITE (*,2002)
 2002 FORMAT(//,' Soil hydraulic functions of pressure head hp ',/)

   22 PRINT *,' Pressure head(cm):for exit use hp>0,to get a list',
     # ' hp>100'
      READ (*,*) hp
      if (hp .gt. 100.0)  goto 25
      if (hp .gt. 0.0)    goto 1

C     unsaturated hp is <0, unsaturated h >0
      h=-hp
      CALL VANGEN
      CALL PRESS
      GOTO 22

   25 PRINT *,'  top, bottom  '
      print *,'  Both of them should be <0 ! '
      READ (*,*) hpinit, hpfinal
      write (*,2004)
      write (7,2004)
 2004 format(5X,/,8X,'h      theta       eff.sat.    dth/dh       ',
     *'cond')
      hincr=(-hpfinal+hpinit)/10.
      DO 27  i=1, 11
        h=-hpinit+hincr*dfloat(i-1)
        CALL VANGEN
        WRITE (*,2006)  -h, TH, RWC, SWC, COND
        WRITE (7,2006)  -h, TH, RWC, SWC, COND
 2006   FORMAT(2X,5(E11.4,1X))
   27 CONTINUE
      GOTO 22

C     *********************   MENUE vG/M inverse   *****************
   30 M=3 
      write (7,1001) ! underscore
      WRITE(*,3003)
 3003 FORMAT(//,' Soil hydraulic functions of theta ')
      write (7,3003)
      if (kdur .eq. 1) then
        print *,' Inverse bimodal function not yet implemented'
        goto 1
      end if

   31 PRINT *,' Input of theta (cm3/cm3):   '
      READ(*,*) th
      IB=3
      IF (th .LE. thr .OR. th .GE. ths) THEN
         PRINT *,' rejected, must be between theta-r and theta-s  '
         GOTO 31
      END IF
      CALL VANGEN
      CALL PRESS 

      PRINT *,'  Exit from this menu item ? (no=0,yes=1)   '
      READ (*,*) NY
      IF(NY .EQ. 1) GOTO 1
      GOTO 31

C     **********************   MENUE: PHI    ********************
   40 M=4
      PRINT *,'  '
      write (7,1001)  ! underscore
      write (7,4004)
      write (*,4004)
 4004 format(2X,/,2X,'Matrix flux potential (Kirchhoff transform)')

   41 PRINT *,'  Lower and upper reference pressure head:'
      read (*,*) hpbott, hptop
      if (hpbott .ge. 0. .or. hptop .ge. 0.) then
        print *,' For zero pressure, please use menu point 8'
        print *,' For hp>0 matrix flux potential is given by',
     *  '(Ks*h).  I am afraid you don`t want to get this '
      goto 42
      end if 

   45 continue
      hbott=-hpbott
      htop =-hptop
      call MFP(hbott,htop,phi) 

      PRINT *,' phi=   ',PHI, ' cm*cm/d'
      write (7, 4007)  hpbott, hptop, phi
 4007 format(2X,/,2X,' h_bottom, h_top, phi: ',3E13.4,' cm2/d')
   42 continue

      print *, ' Exit from this menu point (no=0, yes=1)? '
      read (*,*) ny
      if (ny .eq. 1) goto 1  

      GOTO 41

C     ******************** MENU: Steady vertical flow  *********   
   50 M=5

      write (7, 1001)  ! underscore
      write (7, 5001)
 5001 format(2X,//,2X,'STEADY-STATE VERTICAL FLOW ')
      WRITE (*,5005)
 5005 FORMAT(//,'  Steady-state vertical flow, ',
     *  'UPWARD POSITIVE, DOWNWARD NEGATIVE ',/) 
     
C     -----    Calculate upper boundary condition for option 2 -----
   51 continue
      IB=2
      if (kdur .eq. 0) then
       h=63
       call VANGEN
       fc=th       ! something like ancient field capacity
       h=15800
       call VANGEN
       pwp=th
       IB=3
       th=pwp+0.5*(fc-pwp) ! midpoint between fc and pwp
       call VANGEN
       hpdry=-h         ! proposed threshold value of hp
       IB=2
      end if
C     -----     Prepare layered soil                     -----     
C     -----     Initial elevation of the lower bounds:   -----  
      zlayer(1)=0.
      zlayer(2)=0.
      zlayer(3)=0.
      zlayer(4)=10000.  ! cm
      print *,' Do you want to take into account layered soil?(0,1)'
      read (*,*)Layer

      if (Layer .eq. 1) then
       if (kdur .eq. 1) then
         print *,' Layered soil AND bimodal porosity not implemented'
         print *,' Not yet'
         goto 50
      end if
       print *,' Parameters given assumed to be valid in lowest ',
     # 'layer (1), 3 layers assumed '
       thrl(1)  =thr
       thsl(1)  =ths
       alphal(1)=alpha
       gnl(1)   =gn
       gml(1)   =gm
       expol(1) =expo
       condsl(1)=conds

C      --- read parameters of layers 2 and 3
       goto 55 
   54  print *,' Error, please repeat input '
   55  continue
       do 52 j=2,3
       print *,' Lowest elevation of layer #',j,
     # '(give cm above water table):'
       read (*,*) zlayer(j)
       print *,' thr, ths, alpha, n,  expo, conds '
       read (*,*,ERR=54) thrl(j),thsl(j),alphal(j),gnl(j),expol(j),
     #  condsl(j)
   52  continue

       write(7,5010)(j,zlayer(j),
     # thrl(j),thsl(j),alphal(j),gnl(j),expol(j),condsl(j),j=1,3)
 5010  format(2X,/,
     # 2X,'Layer Low Bound theta-r    theta-s    alpha',
     # '       n      expo      conds   ',/,3X,
     # I4,F5.1,2X,6F10.5)
      end if
      
C     -----     Two options: z(h) or h()     -----      
      print *,'      '
      PRINT *, ' press 1 for z(h), press  2 for h(z) '
      print *, '                      Explanation:   '
      print *, ' option 1: pressure head h(z) above groundw.'
     *,' table for one chosen value of q '
      print *,' option 2 calculates height z for a'
     *,' variety of q using one boundary value of h'
      READ (*,*) NY
      print *,'   '
C
      IF (NY .EQ. 2) GOTO 520  
      
C     -----  Prepare option 1:     -----
      print *,' flow rate, cm/day : '
      print *,' please note: q is positive upward, ',
     *'negative q means downward flow '
      read (*,*) q 
      print *,' smallest desirable hp in case of q>0 or greatest z',
     # ' in case of q<0 '
      read (*,*) ylimit

      dz=.5
      if (conds .le. 5.) dz=0.25
      h=0.0
      cond=conds
      prevh = 0.
      prevz = 0.
      z=0.
      if (Layer .eq. 1) call Bound(z)
      i=0
C
      write (7, 5015) q
 5015 format(2X,' q= ',F5.2,' cm/day')
      write (*, 5016)
      write (7, 5016)
 5016 format(2X,/,2X,'Elevation above   pressure head',/,
     # 2X,'water table,cm       cm ')

      if (conds .lt. 10. .and. -q/conds .ge. 0.5) then
        print *,' Warning, soil may get close to saturation and ',
     # 'solution might be instable '
        print *,' Check: Is K of final hp approaching given q ?'
        dz=0.1
      end if
C
C     -----     Numerical solution  option 1   -----
  510 z=z+dz
      hdh=.5*dz*(q/cond+1.)
      h=h+hdh
      CALL VANGEN
      h=h-hdh
      dh=dz*(q/cond+1.)
      h=h+dh
C
C     -----  Organize output     -----
      bool1=.false.
      if (q.ge.0. .and. abs(h-prevh).ge.2.+abs(h)/50.)bool1=.true.
      if (q.lt.0. .and. abs(z-prevz).ge.2.+z/10.     )bool1=.true.
      if (bool1) then
        hp=-h
        WRITE (7,5017) z, hp
 5017   FORMAT(F12.6, 5X, E14.4)
        prevh=h
        prevz=z 
      end if
C
C     -----  First exit: ylimit reached     -----
      bool1=.false.
      if (q.ge.0. .and. h .ge. -ylimit)  bool1=.true.
      if (q.lt.0. .and. z .ge.  ylimit)  bool1=.true.
      if (bool1) then
         print *,' done, limit reached '
         print *,' z,h:  ',z,-h
         print *,' ====================== '
         print *,'                     '
         z=0
         if (layer .eq. 1) call bound(z)! restore 
         goto 1
      end if 
C     ----- continue numerical solution     -----
      CALL VANGEN
      dz=DMIN1(ABS(COND/q),0.5D00)
C
C     -----   Second exit: z or q approaching constant values ---
      if (dz .lt. 0.001 .or. abs(dh) .lt. 0.001) then
        hp=-h
        write (*,5017) z, hp
        write (7,5017) z, hp
        if (q .gt. 0.) print *, 'z does not change any more '
        if (q .lt. 0.) print *, 'hp does not change any more ' 
        print * ,' continue with any integer'
        read (*,*) ny
        goto 550  ! job finished
      end if

      if (Layer .eq. 1 ) call bound(z)  ! bound selects parameters
      goto 510                          ! continue procedure 

  520 CONTINUE

C     -----     Capillary rise of groundwater option 2   -----

      PRINT *,' Make sure sat.conductivity is given in cm per day!'
      if (Layer .ne. 1 .and. kdur .eq.0)
     # print *,'For orientation: h of drought point is ',hpdry,' cm'
       print *,' Top boundary pressure head chosen hp= '
       read (*,*) hpmin
      if (hpmin .gt. -10.) then
        print *,' wrong value, hp<-30  cm expected'
        go to 520
      end if
  525 continue
      hmax=-hpmin
C
      DO 530 I=1,25
       q=dfloat(I)*0.02
       z=0
       if (layer .eq.1) call bound(z) ! restore parameters of layer 1

C      ------   Numerical solution option 2    -----       
       h=0
  540  dh=0.2+h/400.
       hdh=dh/2.
       h=h+hdh
       CALL VANGEN
       h=h+hdh
       dz=COND/(q+COND)*dh
       z=z+dz
       if (Layer.eq.1) call bound(z)!selects parameters of soil layers
       IF (h .LT. hmax ) GOTO 540 

       print *,' q,z ', q, z
       capwrite(I,1)=q	 ! arrays for output
       capwrite(I,2)=z
  530 CONTINUE
C
      WRITE (*,5020) hpmin
      WRITE (*,5024) ((capwrite(I,J), J=1,2), I=1,25)
 5020 FORMAT(/,
     *' hmin:',E13.5,'  units:cm/d and cm',/,
     *'    q     z               q     z               q     z ')
 5024 FORMAT(3(1X,F4.2,2X,F6.1,10X))
      WRITE (7,5020) hpmin
      WRITE (7,5024) ((capwrite(I,J),J=1,2),I=1,25)
      print *,'            '
C
  550 print *,' Job finished, for results see output file '
      print *,' ========================================= '
      print *,'                                           '
      if (layer .eq. 1 ) then
       z=0
       call bound(z) ! restore first input parameters 
      end if
      GOTO 1

C     *****************   Menue 6: evaporation  ***************
   60 M=6
      write (7, 1001)  ! underscore
      write (*, 6006)
      write (7, 6006)
      if (kdur .eq. 1) then
        print *,' Inverse bimodal function not yet implemented'
        goto 1
      end if
 6006 format(2X,/,2X,'Drying of soils by evaporation ')
  620 PRINT *,'                                       '
      print *,' inside theta, theta<0 -->exit '
      read (*,*,ERR=60)    thetai
      if (thetai .le. 0.0) goto 1

      print *,' theta at drying surface: '
      read (*,*,ERR=60)    theta0
      if   (theta0.le.0.0) goto 1

      ib=3
      x=theta0
      call VANGEN
      diff0=diff
      x=thetai
      call VANGEN
      diffi=diff
   61 print *,' time (days) since 2nd stage drying began : '
      read (*,*,ERR=61) tme
      if   (tme .lt. 1.E-6) goto 60

      deltheta=thetai-theta0

      print *,'        time            q       sum (q(t)*dt)'
      write (7,6011)  thetai, theta0, diffi, diff0, tme
 6011 format(/, ' theta inside= ',F7.4, 9X,
     * 'theta surface=',F7.4,/, ' diff inside= ',E12.4, 5X,
     * 'diff surface =',E12.4, 5X,'time=',F9.4,//,
     * '     time         q            integral q(t)dt ')

      q=deltheta*dsqrt(diff0/(pi*tme))
      cumq=2.*deltheta*dsqrt(diff0*tme/pi)

      write (*,6012) tme, q, cumq
      write (7,6012) tme, q, cumq
 6012 format(3X,3E13.5)
      goto 620

C     ************   Menue 7: Internal drainage   **************
   70 M=7
      notprint=0
      write (7,1001)  !underscore
      write (7,7007)
      write (*,7007)
      write (7,1003)
 7007 format(2X,//,2X,
     # 'Internal drainage of sandy soils, Gardner-Crank iteration')
C
  710 PRINT *,'  Groundwater depth (cm) (lessequal zero means exit) '
      read (*,*) gw
      if (gw .le. 0.0) goto 1
      write (7, 7010)   gw
 7010 format(5X,/,2X,' Groundwater depth',F5.0,' cm')       
C
C     ----- calculate final soil water storage     -----
   71 continue
      N=2*IFIX(sngl(GW))
      IB=2
      bott=0.0
      M=0
      CALL SIMPSON(bott, gw, N, WINF, VANGEN)
      M=7

      write (*, 7012) winf, ths-winf/gw
      write (7, 7012) winf, ths-winf/gw
 7012 format(/,2X,'Equilibrium soil water storage (cm): ',F8.3,
     # 5X,        'drainable porosity: ',F8.5)
C
      PRINT *,    ' MAXIMUM DRAINAGE TIME (days, integer!):   '
   72 READ (*,*)    a
      maxt=ifix(sngl(a))
      write (7,7015)maxt
 7015 format(2X,   'Max drainage time: ',I5,' days')
   75 continue

      write(*,7017)
      write(7,7017)
 7017 format(5X,/,4X, 'Time   ITER       AV.WC      Q(t)/Qinfinite')
C     -----     loop drainage time     -----
      do 712 j=1,maxt
      dt=dfloat(j)
C     -----     assumed entrapped air content    -----
      entrapped=0.02
  720 thinit=(1.-entrapped)*ths
C     -----Amount of drained water in state of equilibrium:     -----
      QINF=thinit*GW-WINF
C     -----     first approximation of final theta     -----
      ITER=0
      h=gw/2.
      ib=2
      CALL VANGEN   
      thfinal=th  ! initial estimation of final theta

      if (thinit .le. thfinal+0.05) then
          write (7,7018)
          write (*,7018)
 7018   format('Soil does not drain over specified water table')
        goto 710
      end if
      if (kdur .eq. 1) then
        print *,' Bimodal hydraulic functions not implemented '
        goto 710
      end if

C     -----     begin of iteration      -----
      N=400  ! Prepare to invoke Simpson
  700 ITER=ITER+1
      CALL SIMPSON (thfinal,thinit,N,DCRANK,CRANK1)
      DCRANK=DCRANK*1.85/(thinit-thfinal)**1.85 !Effective diffusivity
      SU=0.
      DO 701 I=0,3            ! 4 terms of series are calculated
         C3=2.*dfloat(I)+1.
         C3=C3*C3
         C4=8./(C3*PI*PI)
         C5=dexp(-DCRANK*C3*PI*PI*dt/(4.*GW*GW))
         SU=SU+C4*C5
  701 CONTINUE

      QT=QINF*(1.-SU)    ! amount of drained water at time dt
      th2=thinit-QT/GW   ! next approx. of final theta
      if (SU .ge. 1.) then
      print *,'This case cannot be executed '
      goto 70
      end if

C     -----     Accuracy:     ------
      if (ABS(th2-thfinal) .GE. 0.0005) then
         thfinal=th2
         if (ITER .LE. 30) GOTO 700
      end if

      WRITE(*,7020) dt, iter, th2, QT/QINF
      write(7,7020) dt, iter, th2, QT/QINF
 7020 FORMAT(2X,F6.2,4X,I2,7X,F8.5,5X,F8.5)
  712 continue  ! end of drainage days loop

      GOTO 710

C     ***********   MENUE 8: Unit gradient drainage   ****************
   80 M=8
      if (kdur .eq. 1) then
        print *,' Bimodal soil hydraulic function not implemented '
        goto 1
      end if
 
      write (7, 1001) ! underscore
      write (7, 8008)
      WRITE (7, 1003)
      write(*, 8008)
 8008 format(2X,//,2X,'Unit gradient drainage ')
C
  810 PRINT *, ' Length of soil column (cm), less than zero means exit'
      read (*,*) coLL
      if (coLL .le. 0.0) goto 1

      write (7,8010) coLL
 8010 format(5X,/,2X,' Length of soil column: ',F6.1)
      PRINT *,'  first and last day of drainage time (integer), '
   81 READ(*,*)  mint, maxt
   82 continue
   
      write (*,8012)
      write (7,8012)

      do 85 j=mint,maxt
      tme=dfloat(j)
      ZT=0.
      PREVRWC=.999
      CALL ZERO2(ZT,PREVRWC,DUMMY)

      SLMAX=DKDS*tme	  ! conditions met?
      tmin=coLL/DKDS
      if (coLL .GT. SLMAX .OR. tme .LT. tmin) then
         PRINT *,' max. soil column length, min. t  ',SLMAX,TMIN
         GOTO 810
      end if

      N=100
      PREVRWC=.95
      BOTT=.1
      TOP=coLL+0.05
      CALL SIMPSON (BOTT, TOP, N, W, NEWTON)

      write(*,8014) tme, W
      write(7,8014) tme, W

 8012 format(5X,/,2X,'Time (days)  W (cm) ')
 8014 format(2X,F4.0,9X, E12.6)
   85 continue

      GOTO 810

C     ************   MENUE 9: 1D and 3D infiltration   **************
   90 M=9
      PRINT *,'         '
      write (7, 1001) ! underscore
      print *,'  *****  1D ponded  and 3D disc infiltration ***** '

  910 PRINT *,' Initial soil water pressure head prior to inf.'
      print *,' Positive or zero h means exit'  
C     -----     Initial theta and pressure head     ----- 
      read (*,*) hpinit
      if (hpinit .ge. 0.) goto 1
      h=-hpinit
      ib=2
      call VANGEN
      thinit=th
      condi=cond

C     -----     Hysteresis:     -----      
      print *,' Do you want to double alpha as a rough approximation ',
     # 'of the wetting branch of soil water retention? (yes=1, no=0)'
      read (*,*) dalpha
      alpha=alpha+dalpha*alpha
      C1=alpha**gn
      if (dalpha .gt. 0.1) write (7,9009)alpha
C     hysteresis approximation: dalpha=1, otherwise dalpha=0
 9009 format (5X,' alpha temporarily changed to ', F8.5)

C     -----     Infiltration from tension disc     -----
      print *,' Do you want to deal with disc infiltration? Yes=1 '
      kdisc=0
      hponded=0.
      hpdisc =0.
      read (*,*) kdisc
      if (kdisc .eq. 1) then 
         print *,' Pressure head at disc, must be <0 '
         read (*,*) hpdisc
         print *,' Radius of the disc, cm '
         read (*,*) rdisc
         write(7,9011) rdisc
 9011    format(2X,/,2X,'disk radius (cm) = ',F5.1)
         h=-hpdisc  ! hpdisc is always <=0
      else
C     -----     1D ponded infiltration     -----
        print *,' Height of ponded water on soil surface (cm) '
        read (*,*)hponded
        h=0
      end if

      ib=2
      call Vangen
      thsurf=th
      condsurf=cond
C     entrapped air is assumed
      if (h .lt. 5.0) thsurf=0.95*thsurf
      dtheta=thsurf-thinit

C     degenerated:
      if (dtheta .lt. 0.01) then
         print *,' No empty pore space available '
         goto 90
      end if

C     -----   calculate PHI   -----
      htop=h+0.1
      call MFP (htop,-hpinit,phi)
      PRINT *,' Matrix flux potential,phi=:', PHI, ' cm*cm/day'
C
      if (kdisc .eq.1) hpsurf=hpdisc
      if (kdisc .ne.1) hpsurf=hponded
      write(7,9015) hpsurf, hpinit, phi
 9015 format(5X,//,2X,' *****  1D/3D INFILTRATION     *****',//,
     *2X,'Presssure head at soil surface:',     F7.1,/,
     *2X,'Pressure head prior to infiltration:',F7.1,/,
     *2X,'Matrix potential ',                   E13.6,' cm*cm/day')

C     ----- Barry-HAVERKAMP - 1D INFILTRATION     ----- 

      PRINT *,'                 '
      PRINT *,  ' DTHETA, CONDI =',DTHETA, CONDI
      SORPT=dsqrt(1.82*PHI*DTHETA) ! ( cm/dsqrt(day) )
      PRINT *,' SORPITIVITY=',SORPT
      T1=SORPT*SORPT+2.*condsurf*hponded*dtheta
      T2=(condsurf-condi)**2

C     --- Calculate lambda-s and gamma   ---
      N=100
      BOTTOM=1000.
      TOP=50000.
      CALL SIMPSON(BOTTOM, TOP, N, SLAMBDA1,FUENTE)
      BOTTOM=100.
      TOP=1000.
      N=500
      CALL SIMPSON(BOTTOM, TOP, N, SLAMBDA2, FUENTE)
      TOP=100.
      if (kdisc .ne. 1) bottom=0.
      if (kdisc .eq. 1) bottom=-hpdisc
      CALL SIMPSON(bottom, TOP, N, SLAMBDA3,  FUENTE)
      SLAMBDA=  (SLAMBDA1+SLAMBDA2+SLAMBDA3)/condsurf
      HSTR=DMIN1(-SLAMBDA*(condsurf-condi)/condsurf,-1.D00)

      PRINT *,'            '
  915 PRINT *,'  HSTR=',HSTR

      GMA=2.*condsurf*(hponded-hstr)*DTHETA/T1
      if (gma .le. 0.  .or. gma .ge. 1.) gma=0.5

      PRINT *,' GMA= ',GMA
      write(7,9017) dtheta,sorpt,hstr, gma
 9017 format(2X,'delta theta:',F6.3,
     */,2X,'Sorptivity :',E14.6,' cm/day**0.5',
     */,2X,'Dependent parameters hstr and gamma: ',2F8.2)

C     -----  DLT dimensionless time, DLCUMI dimensionless cum. inf.
C     -----  print title lines :     -----
      if (kdisc .ne. 1) then
        write (*, 9020)
        write (7, 9020)
 9020   format(/,2X,' Time (min.)   cumulative infiltration, cm ',
     *  /,2X,     '               Haverkamp        Philip ')
      end if 
      if (kdisc .eq. 1) then
         write (*, 9022)
         write (7, 9022)
 9022    format(/,2X,' Time (min.)  Cumulative infiltration, cm3 ')
      end if
C
C     -----     Calculate infiltration (cuminf)     -----
      DO 950 I=1,20
        TIME=dfloat(I)/720.
C       time increment of 2 minutes is converted to days
        CALL RANDEL (T1, T2, condsurf,TIME, SORPT, CUMINF, PHILIP) 
        TMINUTES=dfloat(2*I) ! max infiltration time 40 minutes
C
        if (kdisc .ne. 1) then
         WRITE (*,9025) TMINUTES, CUMINF ,PHILIP
         WRITE (7,9025) TMINUTES, CUMINF, PHILIP
 9025    FORMAT(2X,3(E12.5,2X))
        end if
        if (kdisc .eq. 1) then
         discinf=pi*rdisc*(rdisc*cuminf+0.75*sorpt**2*time/dtheta)
         write (*,9027) tminutes, discinf
         write (7,9027) tminutes, discinf 
 9027    format(2X,2(E12.5,2X))
        end if
  950 continue


  951 print *,' Any other inf. time (minutes), for exit use t<0'
  952 read (*,*) ETIME
      if ( ETIME .LT. 0.0) then     ! exit
        alpha=alpha-dalpha*alpha/2. !restore original alpha
        c1=alpha**gn
        GOTO 910
      end if

      TIME=ETIME/1440.
      CALL RANDEL (T1, T2, condsurf, TIME, SORPT, CUMINF, PHILIP)
      if (kdisc .eq. 1) then
        discinf=pi*rdisc*(rdisc*cuminf+0.75*sorpt**2*time/dtheta)
        write (*, 9032) etime, discinf
        write (7, 9032) etime, discinf
        goto 951
      end if

      write (*,9030) etime, cuminf, philip
      write (7,9030) etime, cuminf, philip
 9030 format(2X,' Time=',F8.2,'  Haverkamp:',E12.4,'  Philip:',E12.4)
 9032 format(2X,' Time=',F8.2,'  Cum.inf.: ',E12.4,'  cm3')
      GOTO 951


C     *********  Menu 10: Green and Ampt infiltration  **************

  100 M=10   
      print *,'           '
      write (7, 1001) ! underscore
      write (*, 1070)
      write (7, 1070)
 1070 format(/,' GREEN & AMPT infiltration into groundwater ',
     #  'affected sandy and loamy soils')
      write (7, 1003)

  107 continue
      print *,' Exit from this menu point? (no=0; yes=1) '
      read (*,*) ny
      if (ny .eq. 1) goto 1
      print *,' Soil surface is assumed to be saturated '
      print *,' Antecedent pressure head in soil '
      read (*,*) hpinit
      ib=2
      h=-hpinit
      call VANGEN
      deltath = 0.95*ths-th

      hbott=0.1
      htop=h
      call MFP(htop,hbott,phi)
      hF=-phi/conds
      print *,' hF after Neumann(19030)Kutilek-Nielsen 1994: ',hF
      print *,' Pressure head at wetting front hF: '
      read (*,*) hF
      hF=DABS(hF)

      write (*,1071) hpinit, deltath, hF
      write (7,1071) hpinit, deltath, hF
 1071 format(/,2X,' hpinitial, deltatheta, hF:',/,2X,3F10.3,//,
     *2X,' Front depth     time          cumulative infiltration',/,
     #2X,'  cm             minutes           cm' )

      do 105 i=1,60
         WFD=dfloat(i)  ! WFD is the wetting front depth
         cuminf=WFD*deltath
         time=deltath/conds*(WFD-hF*DLOG(1.D00+WFD/hF))
         write (*,1072) WFD, time*1440., cuminf
         write (7,1072) WFD, time*1440., cuminf
 1072    format(2X,F4.0, 11X,E12.4, 5X,E14.5)
  105 continue 

      goto 107

C     **************************Menu 11   *************************
C     **********           Furrow irrigation     ***** 
C     Warrick, A.W.; Amoozegar-Fard,A.; Lomen, D.O.1979
  110 M=11
      write (7, 1001)  ! underscore
      write (*, 1107)
      write (7, 1107)
      write (7, 1002)
 1107 format(//, 1X,'Furrow irrigation: Pressure head at midpoint ',
     *'between furrows')

  112 print *,' Spacing between furrows,Unit:cm, value<0 means exit'
      read (*,*)      SL
      if (SL .lt. 0.) goto 1

      print *,' Source strength',
     *        ' given in liter per day per meter furrow length '
      read (*,*) Qirr
      if (Qirr .lt. 0.) goto 1
      Qirr=10.*Qirr    !  conversion to (cm*cm/d)

      ib=2  ! approximation:
      h=60  ! coincidence of vanGen-cond and Gardner-cond at h=60
      call VANGEN
      Galpha=-1.0D00/h*DLOG(cond/conds)  ! (alpha)=1/cm
      if (Galpha*SL .gt. 10.) print *,' method not valid for alpha*L>10'

C     -----     pour irrigation water over area     -----
      q=Qirr/SL  !  (q)=cm/d
C
      print *,' Evapotranspiration rate, cm/day '
      read (*,*) u
      if (u .lt. 0.0) print *,' evapotranspiration cannot be <0 !'
      ru=u/q     !   ru dimensionless

      print *,' depth of main root water uptake, cm '
      read (*,*) zroots

      arg1=qirr/(SL*conds)  !  dimensionless
      arg2=dexp(-0.24*Galpha*SL)+ru/(Galpha*zroots)*
     #    (dexp(-Galpha*zroots)-1)
      if (arg2 .le. 0.0) then
       print *,' Irrigation does not meet evapotranspiration demand'
       print *,' Choose narrower furrow spacing or larger ',
     * 'uptake depth or higher source strength'
        goto 110
      end if

      hmidp=1.0D00/Galpha*DLOG(arg1*arg2)

      print *,' pressure head at midpoint between furrows: ',hmidp,'cm'
      write (7,1108) SL, Qirr/10., Galpha, u, ru, zroots, hmidp
 1108 format(5X,/,
     *2X,' Spacing of furrows, cm: ',                     T50,F5.0 ,/,
     *2X,' Source strength, liter/day/m ',                T50,E12.5,/,
     *2X,' Equivalent alpha of Gardners function, 1/cm: ',T50,E12.5,/,
     *2X,' Evapotranspiration, cm/d :',                   T50,F6.3 ,/,
     *2X,' Fraction of evapotransp. to irrigation:',      T50,F6.3 ,/,
     *2X,' Depth of root water uptake, cm: ',             T50,F6.0 ,/,
     *2X,' Soil water pressure head at midpoint, cm: ',   T50,E12.4)

      goto 112

C     ************************  Menu 12   **************************
C     *****     1D steady-state groundwater flow     *****
  120 M=12
      write (7, 1001) ! underscore
      write (*, 1207)
      write (7, 1207)
      write (7, 1002)
 1207 format(/,' Horizontal steady-state groundwater flow ')

  128 continue
      print *,' Thickness of aquifer, m (negative means exit): '
      read (*,*,ERR=120)     aqthick
      if (aqthick .lt. 0.0 ) goto 1
      phiconf=aqthick**2/2.  ! prepare test phreatic/confined

      print *,' Groundwater recharge mm/year: '
      read (*,*,ERR=120)  qN
      qN=qN/365.24E+03   ! conversion to m/d

      Aqconds=conds/100.  ! conversion to m/d
      print *, ' Hydraulic head at position x=0, meter '
      read (*,*,ERR=120) H0
      phi0=H0*H0/2.  ! Girinski's potential, if confined then:
      if (H0 .gt. aqthick)  phi0=H0*aqthick-aqthick**2/2
      print *,' phi0= ',phi0

      print *, ' distance between left and right boundary R, m '
      read (*,*) RR

  121 print *,' Hydraulic head boundary condition at x=R?(0=no,1=yes)'
      read (*,*,ERR=121) ibc  ! boundary condition indicator

      if (ibc .eq. 1) then
  122   print *,' Hydraulic  head at R (m):'
        read (*,*, ERR=122)  HR
        phiR=HR*HR/2.                                     ! phreatic
        if (HR .gt. aqthick) phiR=HR*aqthick-aqthick**2/2 ! confined
      else
        ibc=2
        print *,' spec.water flow at position R, m*m/day '
        read (*,*) QR
        phiR=phi0-RR*QR/Aqconds+qN*RR*RR/(2.*Aqconds)
        if (phiR .lt. phiconf) HR=dsqrt(2.*phiR)
        if (phiR .ge. phiconf) HR=phiR/aqthick+aqthick/2.
      end if
      print *,' phiR= ',phiR
C
C     -----   water divide?     -----
C
      bool1=.false.
      bool2=.false.
      xws=AqCONDS*(HR*HR-H0*H0)/(2*RR*qN)+RR/2.
      if ( H0 .lt. aqthick .and. HR .lt. aqthick) bool1=.true.
      if (xws .gt. 0.0 .and. xws .lt. RR)         bool2=.true.

      if (bool1 .and. bool2) then
         print *,' water divide at ',xws,' m'
      else
         xws=0.
      end if

      write(7,1201)aqthick,qN*365.24E+03,H0,RR,ibc,HR
      write(*,1208)
      write(7,1208)
 1201 format(
     *2X,' Thickness of aquifer, meters: ',            T50,F6.1,/,
     *2X,' Groundwater recharge, mm /year: ',          T50,E12.3,/,
     *2X,' Pressure head at x=0, m: ',                 T50,F7.2,/,
     *2X,' Distance between boundaries, m: ',          T50,F8.1,/,
     *2X,' B.c. at x=R (1=pressure gead,2=flux b.c.):',T50,I3,/,
     *2X,' Pressure head at x=R, m:',                  T50,F7.2)
 1208 format(5X,/,5X,'x (m)         Hx (m)       Qx (m*m/day)')
C
C     -----   Analytical solution to 1D steady-state flow equation ---

      do 125 i=1,16
        j=i-1
        x=dfloat(j)*RR/15.
        phix=phi0+x*(phiR-phi0)/RR+qN*(RR*x-x*x)/(2.*Aqconds)
        Qx=Aqconds*(phi0-phiR)/RR-qN*(RR/2.-x)
        Hx=dsqrt(2*phix)
        if (phix .gt. phiconf) Hx=phix/aqthick+aqthick/2

        write (*,1210) x, Hx, Qx
        write (7,1210) x, Hx, Qx
 1210   format(2X,F8.2,6X,F8.2,6X, E13.5)
  125 continue

      goto 128

C     ************************  Menu 13   **************************
C     *****     RADIAL SYMMETRIC STEADY-STATE GROUNDW. FLOW     ****

  130 M=13
      write (7, 1001) ! underscore
      write (7, 1302)
      write (*, 1302)
      write (7, 1003)
 1302 format(2X,//,2X,'RADIAL SYMMETRIC STEADY-STATE GROUNDW. FLOW')

  135 Aqconds=conds/100.
      print *, ' Thickness of aquifer, m (negative means exit): '
      read (*,*,ERR=130)     aqthick
      if (aqthick .lt. 0.0 ) goto 1

      print *,' Radius of well pipe, m: '
      read (*,*) r0
      print *,' Groundwater recharge mm/year: '
      read (*,*,ERR=120)  qN
      qN=qN/365.24E+03   ! conversion to m/d

      print *,' Hydraulic head prior to pumping, m '
      read(*,*) HR
      phiR=HR*HR/2.

      print *,' Required or known volume flow, m3/day: '
      print *,' Well is origin of r-axis, therefore'
      print *,' flow from aquifer towards well means V<0 ! '
      read (*,*) Vdot
C     ----- At Rmax no effect on groundwater level 
C     ----- Assumption: No other wells, no lakes or rivers nearby

      Rmax=dsqrt(ABS(Vdot)/(pi*qN))
      aux=Rmax/r0
      if (aux .le. 0.) then
	print *,' Error in rO or qN'
	goto 130
      end if

      DN=DLOG(aux)
      Phi0=PhiR-DN/(2*pi*Aqconds)*(pi*qN*(r0**2-(Rmax**2-r0**2)/
     # (2*DN))-Vdot)
      aux=2.*Phi0
      if (aux .le. 0.0) then
        print *,' Phi0 less zero '
        goto 130
      end if
      H0=dsqrt(aux)
      print *,'         Rmax(m), H0(m) ',Rmax, H0

      write(7,1301) aqthick,r0,qN*365.24E+03,HR,Vdot,Rmax,H0
 1301 format(5X,/,
     *2X,'Thickness of aquifer, m:',           T50,F7.1,/,
     *2X,'Radius of well pipe, m: ',           T50,F5.2,/,
     *2X,'Groundwater recharge, mm/year:',     T50,F7.0,/,
     *2X,'Hydraulic head prior to pumping, m:',T50,F7.1,/,
     *2X,'Volume flow, m3/day : ',             T50,F10.3,/,
     *2X,'Range, m : ',                        T50, F8.0,/,
     *2X,'Hydraulic head at x=0 (position of the well), m:',T50,F9.3,
     #/,2X,'================================================',/
     #  2X,'.')

      goto 135


C     **************  Menu 14: Solute transport   *****************
  140 M=14
      write (7, 1001) ! underscore
      write (7, 1405)
      write (*, 1405)
      write (7, 1003)
 1405 format(2x,/,' Steady-state piston flow of a solute, linear ',
     # /,' sorption and first-order decay')
  145 continue
      print *,' Half-life period of compound, days(<0 means exit)'
      read (*,*) thalf
      if (thalf .lt. 0.) goto 1

      print *,' bulk density, g/cm3:(if unknown, type 0) '
      read (*,*) rhod
      if (rhod .lt. .1) rhod=2.65*(1.-ths)  ! peat not considered

      print *,' Linear adsorption coefficient, Kd, cm3 water/g soil '
      read (*,*) akd

      print *,' soil water pressure head, cm: '
      read(*,*) hp
C     unsaturated hp is <0, h=-hp
      h=-hp
      ib=2
      call VANGEN
      q=-cond

      Retard=1.+akd*rhod/th  ! coefficient of retardation
      print *,' Depth beneath soil surface to be considered, cm'
      read (*,*)depth
      BT=-depth*th*retard/q  ! breakthrough time

C     ------ this is the equation:
      relconc=dexp(-0.69315*BT/thalf)

      write (7,1401) thalf,rhod,akd,hp,Retard, depth
 1401 format(5X,/,
     *2X,'Half-life period of compound, days:',T50,E12.3,/,
     *2X,'Bulk density, cm/cm3: ',             T50,F7.3, /,
     *2X,'Distribution coefficient Kd, cm3/g:',T50,E12.4,/,
     *2X,'Soil water pressure head ,cm :',     T50,E12.4,/,
     *2X,'Retardation coeff. R: ',             T50,F8.3, /,
     *2X,'Depth considered, cm: ',             T50,F7.1)

      write (*,1402) BT, relconc
      write (7,1402) BT, relconc
 1402 format(5X,/,2X,'Arrival time (days) and relative concentration ',
     *'in depth chosen: ',/,2X,2E12.4)

      goto 140

C     **********   Menu 15: Breakthrough curve, step input   ********
  150 M=15
      write (7, 1001)  ! underscore
      write (7, 1510)
      write (*, 1510)
      write (7, 1003)
 1510 format(2X,//,2X,'LAPIDUS & AMUNDSON SOLUTE TRANSPORT'
     # ,/,2X,' STEP INPUT BREAKTHROUGH CURVE ')
      print *,' Dispersivity in cm (negative value means exit):'
      read (*,*) dlambda
      if   ( dlambda .lt. 0.0) goto 1

      print *,' Liquid diffusion coefficient in water, cm2/d: '
      read (*,*) D0

      print *, ' Cross sectional area of soil column, cm*cm '
      read (*,*) Area
      print *, ' Water flow, given in cm3/day (amount) '
      read (*,*) vwater
      q=vwater/Area

      print *,' immobile water content'
      read (*,*) thimm
      thmobile=ths-thimm
      v=q/thmobile

      Deff=v*dlambda+D0*thmobile**3.333/ths**2  ! Jury, Gardner

      print *, ' Coefficient of retardation: '
      read (*,*) retard
      print *, ' Length of soil column, cm '
      read (*,*) depth

      write (7,1507)Area,vwater,thmobile,dlambda,D0,v,Deff,
     #  retard,depth
 1507 format(5X,/,
     *2X,'Cross-sectional area of soil column: ',         T50,E12.4,/,
     *2x,'Water flow, cm3/day: ',                         T50,E12.4,/,
     *2x,'Mobile water content cm3/cm3 :',                T50,E12.4,/,
     *2X,'Dispersivity, cm',                              T50,E12.4,/,
     *2X,'Diffusion coefficient in bulk water, cm2/day: ',T50,E12.4,/,
     *2X,'Pore water velocity, cm/day: ',                 T50,E12.4,/,
     *2X,'Eff. disp./diff. coefficient, cm2/day:',        T50,E12.4,/,
     *2X,'Coefficient of retardation: ',                  T50,E12.4,/,
     *2X,'Length of soil column, cm: ',                   T50,E12.4,//,
     *2X,'Time (days)    Relative effluent concentration')

  155 continue
      print *, ' relative conc. is to calculate for time span'
      print *, ' beginning at (days) (time<0 -> exit): '
      read (*,*) tmin
      if (tmin .lt. 0) goto 1
      print *,' ending at (days) '
      read (*,*) tmax
      if (tmax .le. 0) goto 1
      print *,' Time        Rel. effluent conc. ' ! head line

      arg=v*depth/Deff
      if (arg .gt. 100.) then
       print *,' ERROR: v*depth/Deff greater 100 '
       goto 150
      end if
      DVDD=dexp(arg)

      do 152 i=1,26
       time=tmin+(i-1)*(tmax-tmin)/25.
       z1=retard*depth-v*time
       z2=retard*depth+v*time
       DN=Deff*retard*time
       if (DN .gt. 1.D-8) then
         DN=2.*dsqrt(DN)
       else
       print *,'ERROR: Deff*R*time smaller than 1E-8 '
       goto 150
       end if
       u1=erff(z1/DN)
       u2=erff(z2/DN)
C
       relconc=0.5*(1.-u1)+0.5*DVDD*(1.-u2)
       write (*,1508) time, relconc
       write (7,1508) time, relconc
 1508  format(D12.4,5X,D12.4)
  152 continue

      goto 155

C     ************************  Menu 16   **************************
C     *****           breakthrough curve, pulse input          *****
  160 M=16
      write (7, 1001)  ! underscore
      write (*, 1605)
      write (7, 1605)
      write (7, 1003)
 1605 format(2X,//,2X,'JURY & SPOSITO PULSE INPUT EFFLUENT ',
     # 'CONCENTRATION')

      print *,' Dispersivity in cm (negative value means exit):'
      read (*,*) dlambda
      if   ( dlambda .lt. 0.0) goto 1

      print *,' liquid diffusion coefficient in water, cm2/d: '
      read (*,*) D0

      print *, ' Cross sectional area of soil column, cm*cm '
      read (*,*) Area
      print *, ' Water flow, given in cm3/day '
      read (*,*) vwater
      q=vwater/Area

      print *, ' immobile water content cm3/cm3 '
      read (*,*) thimm
      thmobile   =ths-thimm
      v=q/thmobile

      Deff=v*dlambda+D0*thmobile**3.333/ths**2

      print *, ' Coefficient of retardation: '
      read (*,*) retard
      print *, ' Length of soil column, cm '
      read (*,*) depth
      print *, ' Mass of solute pulse, g/cm2 '
      read (*,*) pm

      write (7,1607) Area,vwater,thimm,dlambda,D0,v,Deff,retard,
     #  depth,pm
 1607 format(5X,/,2X,'Jury & Sposito pulse input solute transport',/,
     #2x,'Cross-sectional area of soil column:',      T50,F12.4,/,
     #2X,'Water flow through soil column cm3/day:',   T50,E12.4,/,
     #2x,'Immobile water content cm3/cm3: ',          T50,E12.4,/,
     *2X,'Dispersivity, cm',                          T50,E12.4,/,
     *2X,'Diffusion coeff. in water, cm2/day:  ',     T50,E12.4,/,
     *2X,'Pore water velocity, cm/day: ',             T50,E12.4,/,
     *2X,'Eff. dispersion/diffusion coeff., cm2/d:',  T50,E12.4,/,
     *2X,'Coefficient of retardation: ',              T50,E12.4,/,
     *2X,'Length of soil column, cm: ',               T50,E12.4,/,
     *2X,'Pulse mass g/cm2: ',                        T50,E12.4,//,
     *2X,'Time (days)    Effluent concentration, g/cm3')

  165 continue
      print *, ' Relative conc. is being calculated for time span'
      print *, ' start time, days(time<0 -> exit): '
      read (*,*) tmin
      if (tmin .le. 0.0) goto 1
      print *,' end time, days: '
      read (*,*) tmax
      if (tmax .le. 0.0) goto 1
      print *,' Time,days        Effluent conc.g/cm3 '

      do 161 i=1,26
        time=tmin+(i-1)*(tmax-tmin)/25.
        conc=retard*depth*pm/(v*thmobile*dsqrt(4.*pi*Deff*time**3))*
     #  dexp(-(retard*depth-v*time)**2/(4.*Deff*time))
        write (*,1608) time, conc
        write (7,1608) time, conc
 1608   format(E12.4,3X,E12.4)
  161 continue

      goto 165


C     ******************   Menu 17: Csanady   ********************
C     ***** 2D non steady-state solute transport in aquifer   ****
  170 M=17
      write (7, 1001) ! underscore
      write (*, 1701)
      write (7, 1701)
      write (7, 1003)
 1701 format(//,2X,' 2D non steady-state solute transport in 1D ',
     *'horizontal groundwater flow (Csanady equation) ',/,
     *2X,'Pulse input at t=0,x=0, y=0 into entire aquifer,',/,
     *2X,'Assumption: Groundwater flow parallel to x-axis')

      print *, ' Thickness of aquifer, m (negative means exit): '
      read (*,*) aqthick
      if (aqthick .lt. 0.0 ) goto 1

      aqconds=conds/100.   ! conversion to m/d
      print *,' No groundwater recharge considered '
      print *,' Hydraulic conductivity ',aqconds,' m/d'

      print *, ' Hydraulic head at position x=0, meter '
      read (*,*) H0
      phi0=H0*H0/2.
      if (H0 .gt. aqthick) phi0=H0*aqthick-aqthick**2/2.
      print *,' Girinski left boundary is ',phi0, ' m*m'

      print *,' Distance R between left and right boundary, m '
      read (*,*) RR

      print *,  ' Hydraulic  head at x=R (m):'
      read (*,*)  HR
      phiR=HR*HR/2.
      if (HR .gt. aqthick) phiR=HR*aqthick-aqthick**2/2.
      print *,' Girinski right boundary is ',phiR,' m*m'
      QR=aqconds*(phi0-phiR)/RR
      print *,' Specific flow ',QR,' m*m/d'

C     -----     Drainable porosity     -----
      print *, ' Drainable porosity: '
      read (*,*) drainpor

C     -----     Pore water velocity v:     -----
      wh=DMIN1 (aqthick, H0)  !water height
      q=QR/wh                 ! flow rate (flux) m/d
      v=q/drainpor            ! pore water velocity
      print *,' Pore water velocity v, m/day: ',v

C     -----      Solute transport parameters     -----
      print *, ' Mass of solute injected, kg'
      read (*,*) dm
      print *,'  Dispersivity in flow direction, m '
      read (*,*) dLL
      dLT=0.1*dLL

      print *,' coefficient of retardation: '
      read (*,*)Retard
      print *,' beta of dexp(-beta*time) to account for decay,1/days'
      read (*,*)beta

C     ------  calculate concentration at given time and position -----
      print*,  ' time since injection, days. '
      read (*,*) time
      T1=dm/(4.*pi*drainpor*wh*v*time*dsqrt(dLL*dLT))
      T2=v*time/retard

C     -----     Positions     -----
      distp=T2
      print *,' Piston flow distance is ',distp,' m'
      write (7,1706) distp
 1706 format (2X,'Piston flow distance, m: ',E13.5)
      start=0.
      finish=5.*distp
      region=finish-start
      do 174 j=1,10
         yy(j)=dfloat(j-1)
  174 continue
      print *,'  For results please see output file '

      do 175 i=1,50
      do 175 j=1,10
        x=start+dfloat(i-1)*region/50.
        conc=T1*dexp(-(x-T2)**2/(4.*dLL*T2)-yy(j)**2/(4.*dLT*T2))
     #  *dexp(-beta*time)
        xx(i)=x
        cc(i,j)=conc
  175 continue

      write (7,1702)aqthick,H0,RR,HR,QR,drainpor,v,dm,dlL,Retard,
     #  beta,time, (yy(j),j=1,8)

      do 176 i=1,30
        write (7,1703) xx(i),(cc(i,j),j=1,8)
  176 continue
      write (*,1001) ! underscore
 1703 format(F6.2,8(1X,E11.4))

 1702 format(5X,/,2X,' Thickness of aquifer, m:',T50,F12.1,/,
     *2X,' Hydraulic head at x=0, m:           ',T50,F12.1,/,
     *2X,' Distance left to right boundary:',    T50,F12.1,/,
     *2X,' Hydraulic head at x=R: ',             T50,F12.1,/,
     *2X,' Specific flow, m*m/day              ',T50,E12.4,/,
     *2X,' Drainable porosity:                 ',T50,F12.4,/,
     *2X,' Pore water velocity, m/day:         ',T50,E12.4,/,
     *2X,' Mass of solute added to aquifer, kg:',T50,F12.3,/,
     *2X,' Dispersivity in flow direction, m  :',T50,F12.3,/,
     *2X,' Retardation coefficient:            ',T50,F12.3,/,
     *2X,' Decay coefficient beta,1/days:      ',T50,E12.4,/,
     *2X,' Time since injection, days:         ',T50,F12.3,//,
     *1X,'Concentration unit: kg/m3 ',/,    
     *1X,'Distance      Lateral distance (m) from injection well',
     #' perpendicular to groundwater flow direction',/, 6X,8F12.1)

  177 continue
      print *,' Different locations and times: '
      print *,' Type desired time(days), time<0 means exit'
      read (*,*) time
      if (time .lt. 0.0) goto 1
      print *,' type x,y (meter) for location '
      read (*,*) x,y
      T1=dm/(4.*pi*drainpor*wh*v*time*dsqrt(dLL*dLT))
      T2=v*time/retard
      conc=T1*dexp(-(x-T2)**2/(4.*dLL*T2)-y**2/(4.*dLT*T2))
     #  *dexp(-beta*time)

      print *,' time, x, y, conc ',time, x,y,conc
      write (7,1704) time, x, y, conc
 1704 format(2X,'time= ',E10.4,'  x= ',F7.2,'  y= ',F7.3,'  conc= ',
     # E12.6)
      goto 177


  180 M=18
C     ------------- Long-term average total yearly runoff -----------
      print *,'    '
      print *,' ***************************************************'  
      print *,' The prediction of average long-term actual         '
      print *,' evapotranspiration and groundwater recharge was    '
      print *,' excluded from this program and a stand-alone code  '
      print *,' was generated, see first item on this website      '
      print *,' ***************************************************'  
      print *,'  '
      goto 1

C     -----     Menue  19: Steady - state drainage   -------------

  190 M=19            ! Estimation of drain spacing
      write (7, 1921)
 1921 format(/,2X,' Steady-state field drainage, ',
     # 'units here meter and day ')
      write (7, 1001)  ! underscore
      write (*, 1921)
      print *,' exit from this menu point? (0,1)'
      read (*,*)ki
      if (ki .eq. 1) goto 1
      print *, ' tile drainage? (0,1)'
      read (*,*) kdr1
      dgmma=0.2
      if (kdr1 .eq. 1 ) dgmma=0.1

      print *, ' tile diameter or ditch bottom width,m: '
      read (*,*) diam
      print * , 'Thickness of filter layer,m'
      read (*,*) rfilter
      ua=pi*(diam + 2.* rfilter)
      ue=dgmma*ua
      print *, ' Hydraulic head at midpoint over drain, m'
      read (*,*) hgeo
      print *, ' Drain discharge, m/d'
      read(*,*)  QE
      write (7,1922) diam, rfilter, hgeo, QE
 1922 format(/,5X,  'Diam./width  Rfilter    hgeo      QE',
     #  /,8X,3(F6.2,3X),E12.4)

  191 print *,' Description                              case no.'
      print *,' ------------------------------------------------ '
      print *,' homogeneous aquifer                            1 '
      print *,' two-layered aquifer, drain at boundary         2'
      print *,' two-layered aquifer, drain in top layer        3'
      print *,' two-layered aquifer, drain in bottom layer     4'
      print *,' Confining layer on top of water-filled aquifer 5 '
      print *,' Exit drain spacing section                     6'
      read (*,*)kdr2
      goto      (1901,1902,1903,1904,1905,1906),kdr2
 1906 goto 1

C     -----     case 1     -----
 1901 print *,' saturated hydraulic conductivity (Ks), m/d '
      read (*,*)conda
      print *,' drain close to bottom? (0,1)'
      read(*,*) kdr3
      if (kdr3 .eq. 0) goto 1910 ! proceed to cases 1.1.and 1.2

C     -----     case 1.0: homogeneous aquifer,drain on bottom  ----
      DRSP=hgeo/(0.5*dsqrt(QE/conda)-QE*dlog(dgmma)/(pi*conda))
      print *,'DRSP= ',DRSP,'m'  ! test ok
      if (conda .lt. 0.2) print *,' Warning:Condition k>0.2 violated'
      write (7,1908) conda, DRSP
 1908 format(/,2X,'Homogeneous aquifer, drain close to bottom ',
     # /, 2X,'Ks= ',F6.2,' m/d','Drain spacing= ',F6.2,' m')
      goto 190

C     -----     case 1.1: homog. aquifer, dzero small  ------
 1910 print *,' Drain elevation above impervious layer (m):'
      read (*,*) Dzero
      D1=0.5*hgeo+Dzero
      db=1.
      DC=drainC(db,Dzero,ue)
      DRSP=2.*D1*(dsqrt(DC*DC+hgeo/D1*(2*conda/QE-1))-DC)

C     -----  test for case 1.1:
      if (Dzero .le. 0.25*DRSP) then
        print *,' DRSP= ',DRSP,' m'
        write (7,1909)conda,Dzero,DRSP
 1909   format(/,2X,'Homogeneous aquifer, Dzero small',/,2X,
     # 'Ks (m/d)= ',F6.2,' Dzero (m)= ',F6.2,' DRSP (m)= ',F6.2)
        goto 190
      end if

C     -----     case 1.2: dzero large, iteration follows
 1912 DRSPi=DRSP
      k=0
      eps=1000.
      do 1925 while (eps .gt. 0.01)
      DRSP =pi*conda*hgeo/(QE*dlog(DRSPi/ue))
      eps  =dabs(DRSP-DRSPi)
      DRSPi=DRSP
      k=k+1
      if (k .gt. 500) then
        print *,' no convergence '
        goto 1926
      end if
 1925 continue

 1926 print  *,' DRSP= ', DRSP,' m'
      write  (7,1915) dzero, conda, DRSP
 1915 format (/,2X,' Dzero large',/,2X,'Dzero= ',F6.2,' m, Ks= ',
     # F8.4,' m/d',' DRSP= ',F6.2,' m')
      goto 190

C     Case 2: Two-layered aquifer, drain at boundiamry
C     Case 2.1:  cond top/cond bott >0.1,dzero small
C     Case 2.2:  cond top/cond bott <0.1,dzero small
C     Case 2.3:  dzero large

C     -----     case 2     -----
 1902 Print *, ' Two-layered aquifer, drain at boundary '
      print *, ' Drain elevation above imp. stratum (m):'
      read (*,*) Dzero
      print *,'  Ks m/d top layer, bottom layer:'
      read (*,*) condtop, condbott

      condrel=condtop/condbott
      db=1.
      DC=drainC(db,Dzero,ue)

      eps=1000.
      DRSPi=1000.
      do 1930 while (eps .gt. 1.)
       dhat=dzero/(1.+4.*dzero/DRSPi*(DC+0.32))
       if (condrel .ge. 0.1)  ! case 2.1
     # DRSP=2.*dsqrt(hgeo/QE*(condtop*hgeo+2.*condbott*dhat))
       if (condrel .lt. 0.1)  ! case 2.2
     # DRSP=2.*dsqrt(2.*dhat*hgeo*condbott/condtop*(condtop/QE-1.))
       eps=dabs(DRSP-DRSPi)
       DRSPi=DRSP
 1930 continue

      if (dzero .gt. 0.25*DRSP) then  ! case 2.3
        conda=condbott
        DRSP=1000.
        goto 1912
      end if

C     continue with case 2.1 / 2.2:

      print *,    '  DRSP= ',DRSP,' m'  !test ok
      write (7,1917) Dzero, conda, DRSP
 1917 format(/,2x,  'Two-layered aquifer, drain at boundary',/,2X,
     # 'Dzero= ',F6.2,' m, Ks= ',F6.2,' m/d, DRSP= ',F6.2,' m')
      goto 190

C     -----     case 3     -----
 1903 continue
      print *, 'two-layered aquifer, drain in top layer '

C     case 3:   Two-layered aquifer, drain in top layer
C     case 3.1: condtop/condbott >  0.1
C     case 3.2: condtop/condbott <  0.1

      print *,'Enter drain elevation above boundary and thickness ',
     # 'of bottom layer, m '
      read (*,*)    dzero, d2
      print *,    ' Ks cm/d top layer, bottom layer:'
      read (*,*)    condtop, condbott
      write(7,1920) dzero,d2,condtop,condbott
 1920 format(/,2X, 'Two-layered aquifer, drain in top layer ',/,2X,
     # 'Dzero  = ',F6.2,' m, Ks (top layer)= ',F6.2,' m/d',  /,2X,
     # 'Ks bott= ',F6.2,' m/d,thickness of bottom layer= ',F8.4,' m')

      call bmatrix(d2,dzero,condtop,condbott,db)
      DC=  drainC(db,dzero,ue)

C     -----     switch for case 3.1/3.2:     -----

      if (condtop/condbott .lt. 0.1) goto 1932  ! goto case 3.2

C     -----     case 3.1:     -----
      d4  =hgeo/2.+dzero+d2*condbott/condtop
      DRSP=2.*d4*(sqrt(DC*DC+hgeo/d4*(2*condtop/QE-1.))-DC)

      print *,    ' DRSP= ',DRSP,'m'  ! test ok
      write(7,1950) DRSP
 1950 format(2X,  ' DRSP= ',F6.2,'m')
      goto 190

C     -----     Case 3.2     -----
 1932 continue
      d5=  dzero+d2*condbott/condtop
      DRSP=2.*d5*(dsqrt(DC*DC+hgeo/d5*(2.*condtop/QE+QE/condtop-3.))
     #  -DC)
      print *,    ' DRSP= ',DRSP,' m'  ! test ok
      write(7,1950) DRSP
      goto 190

C     -----     case 4     -----

 1904 print *, ' case 4: two-layered aquifer, drain in bottom layer'
      print *, ' Distance drain to upper boundary between layers '
      read (*,*) d6
      print *, ' Distance drain to impervious bottom '
      read (*,*) dzero
      print *, ' Ks m/d top layer, bottom layer:'
      read (*,*) condtop, condbott

      d7  =dzero+d6
      db  =1
      DC  =drainC(db,dzero,ue)
      DRSP=2.*d7*(dsqrt(DC*DC+2.*condbott/(condtop*d7)*(hgeo*
     #  (condtop/QE-2.)+d6))-DC)

      print *,    ' DRSP= ',DRSP,' m'
      write(7,1952) d6,dzero,condtop, condbott,drsp
 1952 format(/,2X, 'Two-layered aquifer, drain in bottom layer',/,2X,
     # ' Distance drain to upper boundary between layers ',F6.2,/,2X,
     # ' Distance drain to bottom, Ks top and bottom layer: ',3F6.2,
     # ' Drain spacing (m) = ',F6.2)
      goto 190

C     -----     case 5   -----

 1905 continue
      print *, ' Enter depth of drain beneath land surface '
      read (*,*) ddr
      print *,  'Enter distance drain to confining bottom,dzero'
      read (*,*) dzero
      print *, ' Ks, m/d '
      read (*,*) conda

      dHH=(ddr+QE/conda*dzero)/hgeo 

C     -----     case 5.1     -----

      QL=pi*conda*dHH*hgeo/(8*dzero)*
     # dlog(8*dzero/(pi*sqrt(2.*dgmma*diam*(hgeo+dgmma*diam))))
      argu=pi*(dHH-1.)*conda*hgeo/QL
      DRSPA=4.*dzero/pi*dlog(4./dtanh(argu))

C     -----     case 5.2     -----
      d8=dsqrt(2.*dgmma*diam*(ddr+dgmma*diam))
      DRSPi=500.
      eps=100.

      do 1935 while (eps .gt. 0.01)
      DRSPB=pi*dzero/(0.69315+(dHH-1.)*dlog(2.*DRSPi/(pi*d8)))
      eps=dabs(DRSPB-DRSPi)
      DRSPi=DRSPB
 1935 continue

      if (dzero .lt. 0.33*DRSPA) then
        DRSP=DRSPA
      else
        DRSP=DRSPB
      end  if

      print *,' DRSP= ',DRSP,' m'
      write (7,1955)    hgeo, dzero,conda,drsp
 1955 format(/,2X,'Confining layer on top of water-filled aquifer',/,
     # 2X,'distance soil  surface to drain depth= ',F6.2,' m',/,
     # 2X,'distance drain to  confining  bottom = ',F6.2,' m',/,
     # 2X,'Ks= ' ,F6.2,' m/d',/,
     # 2X,'DRSP= ',F6.2,' m')
      goto 190


C     -----     Menu 20: Non-steady state drainage (homogeneous aquifer) ----

  200 M=0
      ib=2
 2000 print *, ' Non steady-state drainage '
      print *, ' Ks  m/d '
      read (*,*) conda
      print *, ' Radius of drain tube, m'
      read (*,*) rdr
      print *, ' Drain spacing (m) and drain depth (m) '
      read (*,*) DRSP,DDR     ! drain spacing, drain  depth (m)
      print *, ' Distance drain to impervious stratum, m '
      read (*,*) dzero
      print *, ' Initial water level at midpoint above drain (m) ',
     # 'and shape factor (ellipse:0.78, parabola:0.67) '
      read (*,*) HS, cf

      if (HS .le. 0.) then
      print *,' Soil above drain is unsaturated, model applied here',
     #  ' not valid '
       goto 1
      end if

      if (HS .gt. DDR) then
         print *,' Water table above ground surface, not included '
         goto 2000
      end if

      printstep=HS/50.   ! to prepare printpout

      qinf=0.
      print *, ' constant-flux infiltration, m/d (q>0) '
      read (*,*) qinf

      write(7,2030) conda, DRSP, DDR, Dzero, HS, cf, qinf
 2030 format(/,2X,'Non steady-state drainage ',/,
     # 2X,'Ks, m/d                              ',F6.2,/,
     # 2X,'Drain spacing, m                     ',F6.2,/,
     # 2X,'drain depth,   m                     ',F6.2,/,
     # 2X,'Distance drain to impervious stratum ',F6.2,/,
     # 2X,'Initial water level above drain      ',F6.2,/,
     # 2X,'Shape factor                         ',F6.2,/,
     # 2X,'Constant-flux infiltration, m/d      ',F6.4,//,
     # 2X,'Time,d     HS, m    Discharge, m')

C     -----     start  numerical procedure   -----
      discharge=0.
      dt=   0.01  ! days
      t=    0.
      sumdh=0.
      HS2=HS
      he1=3.55-1.6*Dzero/DRSP+2.*(dzero/DRSP)**2    ! prepare Hooghoudt
      dzeff=dzero/(1.+(dzero/DRSP)*(8./pi*dlog(dzero/rdr)-he1))

 2020 t=t+dt
C     -----  first halfstep     -----
      QEin=4.*conda*HS/(DRSP*DRSP)*(2.*dzeff+HS) !Hooghoudt
      hin = DDR-cf*HS
      x=100.*hin
      call VanGen
      dh2=dt/2.*(qinf-QEin)/(cf*(ths-th)) 
      HS2=HS+dh2     ! midpoint HS
      h2=DDR-cf*HS2  ! midpoint suction head

C     -----    midpoint     -----
      x=100.*h2
      call VanGen    ! calculates  midpoint theta
      QE=4.*conda*HS2/(DRSP*DRSP)*(2.*dzeff+HS2)  ! Hooghoudt-Ernst
      discharge=discharge+QE*dt

C     -----   entire time step    -----
      dh=dt*(qinf-QE)/(cf*(ths-th))
      HS=HS+dh

      sumdh=sumdh+dh             ! to control printout

      if (HS .lt. .001) then
        print *,' drainage terminated'
        print *,' Time(d), discharge (m) ', t,discharge
        goto 1
      end if

      if (dabs(sumdh) .ge. printstep) then
       print *,   ' t(d), HS(m), discharge(m) ',t, HS, discharge
       write(7,2040)t, Hs, discharge
 2040  format(2F8.4,4X,E12.4)
       sumdh=0.
      end if

      dt=1.02*dt
      goto 2020
      end

      Function drainC (b,d,u)
C     ****************************
      implicit real*8 (A-H,O-Z)
      DrainC=0.63662*dlog(b*d/u)
      return
      end

      Subroutine BMATRIX (d2,dzero,condtop,condbott,db)
C     *************************************************
      implicit real*8 (A-H,O-Z)
      dimension colv(8), zv (8), bm (8,8)
C     bm (i,j) line, column
      data colv /.1,.25,.5,1.,2.,4.,7.,10./
      data zv  /.1,.25,.5,1.,2.,4.,10.,30./
      data ((bm(i,j),j=1,8),i=1,8) /5*1.,1.5,2.,3.,
     #  3*1., 3*1.5, 2.,3.,
     #  2*1.,2*1.5,2*2.,2*3.,
     #  1.,2*1.5,2.,2*2.5,3.,4.,
     #  1.5,2.,2.5,3*3.,2*4.,
     #  2.,4.,3*5.,3*4.,
     #  4.,2*10.,8.,6.,2*5.,4.,
     #  15.,2*20.,10.,8.,2*5.,4./
C
      zeile = condbott/condtop
      dev=1000.
      do 2 i=1,8
      devi=abs(zeile-zv(i))
      if (devi .lt. dev) then
        dev=devi
        iline=i
      end if
    2 continue

      col=d2/dzero
      dev=5000.
      do 3 j=1,8
      devi=abs(col-colv(j))
      if (devi .lt. dev) then
       dev=devi
       jcol=j
      end if
    3 continue
      db=bm(jcol,iline)

      return
      end


      SUBROUTINE RANDEL(T1,T2,condsurf,TIME,SORPT,CUMINF,PHILIP)
C     ----------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /PAR/   c1, THR,THS, ALPHA, GN, GM, EXPO,hzero, conds,
     *               RN, RM, gn1, gn2,w1,w2, gm1, gm2,alpha1,alpha2,
     #               film,   pfilm

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

      U=1.0E+00
      TWO=2.0E+00
      DLT=TWO*TIME*T2/T1 ! dimensionless time
      T3 =TWO*DLT/3.
      R1 =dsqrt(TWO*DLT)
      A1 =-R1/(1.+R1/6.)-T3
      A2 = U+DLT/GMA
      if (A2 .GT. 0.) then
          A2=LOG(A2)
        else
C         WRITE (*,*) A1,A2,R1,T3,DLT,T1,T2,GMA
          print *,' Error:1+dlt/gma < 0'
	  print *,' Restart infiltration!'
	  A2=-1
	  return
      end if

      SU1=DLT+U-GMA-dexp(A1)
      F1=GMA/(1.+DLT)
      F2=dexp(-T3)
      F3=1.-(1.-GMA)**8*dsqrt(DLT**5)

      SU2=(TWO*GMA+DLT)*A2
      DLCUMI=SU1+F1*(F2*F3+SU2)   !dimensionless cumulative infiltr.
      CUMINF=TIME*CONDI+DLCUMI*T1/(TWO*(condsurf-CONDI))
      PHILIP=SORPT*dsqrt(TIME)+0.6*condsurf*TIME
      RETURN
      END



      SUBROUTINE VANGEN
C     -------------------------------------------------------------
C     PURPOSE: TO CALCULATE WATER CONTENT,SATUR.,SPEC.WATER CAPACITY,
C             CONDUCTIVITY, DIFFUSIVITY AND dK/dTH FROM SUCTION
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /PAR/   c1, THR,THS, ALPHA, GN, GM, EXPO,hzero, conds,
     *               RN, RM, gn1, gn2,w1,w2, gm1, gm2,alpha1,alpha2,
     #               film,   pfilm

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

C     IB    2 theta(pressure head)
C           3 pressure head(theta)

   10 U=1.0D+0
      IF (M  .EQ. 6)  TH=X
      IF (M  .EQ. 7)  TH=X 
      if (M  .EQ. 0)  h=x

      if (kdur .eq. 1 .and. (ib.eq.3 .or. M.eq.6)) then
       print *,' No inverted bimodal function implemented '
       stop
      end if

      if (IB .eq. 3)  then
        RWC=(TH-THR)/(ths-thr)
	RWC=DMIN1(U,   RWC)
	RWC=DMAX1(0.0D00, RWC)
        h=U/ALPHA *(U/RWC**RM -U)**RN
      end if
C
      IF (h .LT. HZERO) THEN
       TH=THS
       COND=CONDS
       RWC=U
       SWC=0.0
       DIFF=1.0E+30
       GOTO 500
      END IF

      c2=ths-thr
      if (kdur .eq. 0) then  ! unimodal:
       C3=h**GN
       C4=U+C1*C3
       C5=C4**GM
       C6=U-C1*C3/(ALPHA*h*C5)
       RWC=U/C5
       SWC=(gn-1.)*c1*c2*c3/(c4*c5*h)
       RELK=C6*C6/C5**EXPO
       cond=conds*RELK
C     -----     Near saturation modified Mualem/vanGenuchten   ---      
       if (mvg .eq. 2 .and. h .lt. 40.) then  
        if (h .lt. 40. .and. h .ge. 4) R=0.2778-0.00694*h
        if (h .lt. 4.)                 R=1.-0.18008*h
        COND=COND*(CONDS/COND)**R
        RELK=Cond/CONDS
        goto 501
      end if

      else       ! bimodal porosity function of DURNER
       d1=(alpha1*h)**gn1
       d2=(alpha2*h)**gn2
       r1=U+d1
       r2=U+d2
       S1=r1**(-gm1)
       S2=r2**(-gm2)
       RWC=w1*S1+w2*S2
       SWC=C2*(w1*S1*gm1*d1*gn1/(h*r1)+w2*S2*gm2*d2*gn2/(h*r2))
       denum=w1*alpha1+w2*alpha2  ! denumerator
       F1=(w1*S1+w2*S2)**expo
       cnum=w1*alpha1*(1-(alpha1*h)**(gn1-U)*S1)+
     #      w2*alpha2*(1-(alpha2*h)**(gn2-U)*S2)
       Relk=(U-film)*F1*(cnum/denum)**2 +    !  Priesack, Peters
     #     film*(w1*S1**pfilm+w2*S2**pfilm)
       cond=conds*RELK
      end if

  501 diff=cond/SWC
      th=thr+C2*RWC

  500 CONTINUE
      if (M .eq. 0) Y=TH
      RETURN
      END


      SUBROUTINE PRESS
C     ----------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /PAR/   c1, THR,THS, ALPHA, GN, GM, EXPO,hzero, conds,
     *               RN, RM, gn1, gn2,w1,w2, gm1, gm2,alpha1,alpha2,
     #               film,   pfilm

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm
      hp=-h
      write(7,1002) hp, th, rwc, swc, relk, cond, diff
      WRITE(*,1002) hp, TH, RWC, SWC, RELK, COND, DIFF
 1002 FORMAT(//,'   PRESSURE HEAD',               T40, E14.6,/,
     1          '   WATER CONTENT',               T40, E14.6,/,
     2          '   RELATIVE WATER CONTENT',      T40, E14.6,/,
     3          '   SPEC. WATER CAPACITY dth/dh', T40, E14.6,/,
     4          '   REL. HYDRAULIC CONDUCTIVITY', T40, E14.6,/,
     5          '   HYDRAULIC CONDUCTIVITY K',    T40, E14.6,/,
     5          '   DIFFUSIVITY',                 T40, E14.6,/)
      RETURN
      END


      SUBROUTINE SIMPSON (BOTTOM, TOP, N, SUM, FUNCT)
C     -----------------------------------------------   
      IMPLICIT REAL*8 (A-H,O-Z)

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

      DH=(TOP-BOTTOM)/N
      X=BOTTOM
      CALL FUNCT
      SUM=Y

      DO 301 I=N/2,1,-1
         X=X+DH
         CALL FUNCT
         SUM=SUM+4.0*Y
         X=X+DH
         CALL FUNCT
         SUM=SUM+Y+Y
  301 CONTINUE

      X=TOP
      CALL FUNCT
      SUM=1./3.*DH*(SUM-Y)
      RETURN
      END


      SUBROUTINE CRANK1
C     -----------------
      IMPLICIT REAL*8 (A-H,O-Z)

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

C     x means theta and is chosen by simpson, ib is equal to 3
      H1=THINIT-X
      F=0.
      IB=3   ! VanGen uses theta as input,result DIFF used by Crank1
      IF (H1 .GT. 1.E-06) THEN
         F=H1**0.85
         CALL VANGEN
         Y=F*DIFF
      END IF
      RETURN
      END

      SUBROUTINE FUENTE
C     ------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /PAR/   c1, THR,THS, ALPHA, GN, GM, EXPO,hzero, conds,
     *               RN, RM, gn1, gn2,w1,w2, gm1, gm2,alpha1,alpha2,
     #               film,   pfilm

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

      CALL VANGEN
      Y=(2.*(COND-CONDI)/((CONDS-CONDI)*RWC)-1.)*COND
      RETURN
      END

      SUBROUTINE NEWTON
C     -------------------
C     -----   purpose: find theta for given z/t   -----
      IMPLICIT REAL*8 (A-H,O-Z)

      COMMON /PAR/   c1, THR,THS, ALPHA, GN, GM, EXPO,hzero, conds,
     *               RN, RM, gn1, gn2,w1,w2, gm1, gm2,alpha1,alpha2,
     #               film,   pfilm

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

      NIT=1
      XA=PREVRWC
      ZT=X/tme
      CALL ZERO2(ZT,XA,YA)
      CALL ZERO2(ZT,1.01*XA,YA1)
      DY=(YA1-YA)/(0.01*XA)

  100 DX=YA/DY
      XN=XA-DX/5.
      NIT=NIT+1

      if (NIT .gt. 500) then
        print *,' subroutine NEWTON no convergence '
	goto 150
      end if

      IF (XN .GT. .9  .OR. XN .LT. 0.1) XN=XA-DX/20.
      if (XN .gt. 1. .or. XN .lt. 0.) then
         print *,' NEWTON failed '
	 goto 150
      end if

      CALL ZERO2(ZT,XN,YN)
      IF (DABS(XN-XA) .LT. 1.D-05)   GOTO 150    
      IF (DABS(DX)    .LT. 2.D-06)   GOTO 150  
      DY=(YN-YA)/(XN-XA)
      YA=YN
      XA=XN
      GOTO 100

  150 Y=THR+(THS-THR)*XN
      PREVRWC=XN
      RETURN
      END


      

      SUBROUTINE ZERO2( ZT, XRWC, ZERO)
C     -------------------------------- 
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /PAR/   c1, THR,THS, ALPHA, GN, GM, EXPO,hzero, conds,
     *               RN, RM, gn1, gn2,w1,w2, gm1, gm2,alpha1,alpha2,
     #               film,   pfilm

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

      XRWC=DMIN1(1.0D00,XRWC)
      XRWC=DMAX1(0.0D00,XRWC)
C     -----     Calculate dK / d theta     -----
      ib=3
      m=8
      step=0.995
      th=thr+XRWC*(ths-thr)
      call VANGEN
C
C     -----  calculate derivative dK/dS
      if (mvg .eq. 2 .and. h .lt. 40.) goto 5  ! analytical solution
      AK=1.-XRWC**RM
      A =1.-AK**GM
      DKDS=2.*A*XRWC**(EXPO+RM-1.)*AK**(GM-1.)+EXPO*XRWC**(EXPO-1.)*A*A
      DKDS=CONDS*DKDS
      DKDT=DKDS/(ths-thr)
      goto 7
C     ---   modified MVG: numerical approximation
    5 cond1=cond
      RWC2 =step*XRWC
      th   =thr+RWC2*(ths-thr)
      ib=3
      call  VANGEN
      cond2=cond
      DKDS =(cond1-cond2)/(XRWC*(1.-step))
      DKDT =DKDS/(ths-thr)

    7 ZERO =DKDT-ZT
      RETURN
      END


      Subroutine MFP (hb, ht, FP)
C     ********************************
C     Calculate matrix flux potential (Kirchhoff transform)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /PAR/   c1, THR,THS, ALPHA, GN, GM, EXPO,hzero, conds,
     *               RN, RM, gn1, gn2,w1,w2, gm1, gm2,alpha1,alpha2,
     #               film,   pfilm

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

C     y=-1.  ! to detect errors: only complete procedure yields y>0

C     -----     bott and top are taken positive here        -----
      htop=ht
      hbott=hb
      if (htop .lt. hbott) then
        h1=htop
        htop=hbott
        hbott=h1
      end if
      phi=0.
      h=hbott
      ib=2
   10 dh=DMAX1(h/300.D00, 0.1D00)
      halfstep=dh/2.
      h=h+halfstep
      call VANGEN
      al=DLOG(1.0D00/relk)/h
      h=h-halfstep

      if (al .lt. 1.D-08) phi=phi+dh*conds
      if (al. ge. 1.D-08) phi=phi+conds/al*
     # (dexp(-al*h)-dexp(-al*(h+dh)))
      h=h+dh

      if ((h+halfstep) .lt. htop) goto 10
      FP=phi
      return
      end


      Subroutine Bound (z)
C     ***********************
      IMPLICIT REAL*8 (A-H,O-Z)

      COMMON /PAR/   c1, THR,THS, ALPHA, GN, GM, EXPO,hzero, conds,
     *               RN, RM, gn1, gn2,w1,w2, gm1, gm2,alpha1,alpha2,
     #               film,   pfilm

      COMMON /GLOBAL/ X,Y, PREVRWC, h,RWC, TH, SWC, RELK, COND,DIFF,
     # DKDS, DKDT, THINIT, condi,GMA, HSTR,tme,IB,M,mvg, kdur,kfilm

      common /Layered/  zlayer(4),thrl(3),thsl(3),alphal(3),gnl(3),
     # gml(3),expol(3),condsl(3)

      do 10 j=1,3
      if (z .le. zlayer(j+1) ) then
       thr=thrl(j)
       ths=thsl(j)
       alpha=alphal(j)
       gn=gnl(j)
       gm=1.-1./gn
       expo=expol(j)
       conds=condsl(j)
       goto 12
      end if
   10 continue
   12 c1=alpha**gn
      rn=1./gn
      rm=1./gm
      return
      end


      Function erff(x)
C     ****************
      IMPLICIT REAL*8 (A-H,O-Z)
      dimension a(6)
      data a/0.0705230784,0.0422820123,0.0092705272,0.0001520143,
     #  0.0002765672,4.30638E-05/
      sign=1.
      if (x .lt. 0.) then
        sign=-1.
	x=-x
      end if
C     x=dmin1(x, 3.0D+00)
      sum=1.
      do 2 i=1,6
        sum=sum+a(i)*x**i
    2 continue
      erff=sign*(1.-1./sum**16)
      return
      end

      Block data
C     ----------
      IMPLICIT REAL*8 (A-H,O-Z)
      common /soils/ soilp(238), flux(68)
      data soilp
     # /1.0,0.0,0.3879,0.26437,1.35154,-0.594,512.094,
     # 2.0,0.0,0.3949,0.11647,1.25425,0.,192.852,
     # 3.0,0.0519,0.3952,0.07097,1.35096,0,89.779,
     # 4.0,0.0,0.4101,0.10486,1.18427,-3.236,141.295,
     # 5.0,0.0,0.4138,0.08165,1.17695,-3.919,109.516,
     # 6.0,0.0,0.4049,0.48458,1.18828,-6.189,420.421,
     # 7.0,0.0,0.4214,0.18023,1.13230,-3.420,305.804,
     # 8.0,0.0,0.3786,0.20387,1.23473,-3.339,285.491,
     # 9.0,0.0,0.3765,0.08862,1.21398,-3.611,119.904,
     # 10.0,0.0,0.3839,0.06005,1.22228,-3.738,83.297,
     # 11.0,0.1406,0.4148,0.04052,1.32416,-2.067,38.43,
     # 12.0,0.07284,0.4091,0.06835,1.20501,-3.226,98.2,
     # 13.0,0.04630,0.4129,0.09955,1.18213,-3.604,169.9,
     # 14.0,0.1492,0.4380,0.07013,1.24572,-3.180,62.531,
     # 15.0,0.1629,0.4530,0.04947,1.17003,-4.099,44.340,
     # 16.0,0.1154,0.4325,0.03401,1.19442,0.,51.979,
     # 17.0,0.0534,0.4284,0.04321,1.16518,-3.227,82.680,
     # 18.0,0.0,0.4030,0.01420,1.21344,-0.561,33.787,
     # 19.0,0.0,0.4003,0.02513,1.19338,-4.032,40.409,
     # 20.0,0.0,0.3946,0.02747,1.22393,-2.728,35.526,
     # 21.0,0.0101,0.4001,0.01868,1.22068,-1.382,29.262,
     # 22.0,0.0053,0.4031,0.01679,1.20668,-1.198,27.708,
     # 23.0,0.0276,0.4162,0.01697,1.20483,-0.767,24.633,
     # 24.0,0.0,0.5238,0.06612,1.05215,0.,154.737,
     # 25.0,0.0,0.4931,0.07339,1.06254,0.,172.507,
     # 26.0,0.0,0.49017,0.07242,1.06062,0.,178.700,
     # 27.0,0,0.4589,0.05500,1.08166,0.,123.765,
     # 28.0,0.0170,0.4372,0.04538,1.12109,0.,88.609,
     # 29.0,0.0,0.4836,0.08402,1.07669,0.,249.862,
     # 30.0,0.07841,0.4374,0.06194,1.14565,0.,118.038,
     # 31.0,0.0,0.4355,0.20919,1.11419,-7.612,322.257,
     # 32.0,0.0,0.4095,0.15041,1.33576,-0.328,285.093,
     # 33.0,0.0,0.3886,0.26188,1.35330,-0.579,507.500,
     # 34.0,0.0,0.37676,0.22065,1.46574,1.3829,8014.556/
      data flux
     #/1.5244E+03,-2.4467,
     # 1.8344E+03,-2.3827,
     # 5.8747E+03,-2.5284,
     # 5.1832E+02,-1.7925,
     # 5.6573E+02,-1.7205,
     # 3.9707E+02,-1.4971,
     # 2.2651E+02,-1.8035,
     # 5.8304E+02,-1.7590,
     # 8.5042E+02,-1.7423,
     # 1.2992E+03,-1.7361,
     # 1.4856E+03,-1.5862,
     # 9.7394E+02,-1.7943,
     # 7.2012E+02,-1.7661,
     # 7.6150E+02,-1.7619,
     # 3.8861E+02,-1.6707,
     # 2.2340E+03,-2.1450,
     # 1.1664E+03,-1.8089,
     # 9.6900E+03,-2.0996,
     # 2.7659E+03,-1.9182,
     # 1.9477E+03,-1.8381,
     # 3.8354E+03,-1.9891,
     # 3.7122E+03,-1.9858,
     # 3.0780E+03,-2.0077,
     # 6.2126E+01,-1.8051,
     # 9.9199E+01,-1.8691,
     # 9.8138E+01,-1.8643,
     # 2.2582E+02,-1.9140,
     # 6.2455E+02,-2.0077,
     # 2.2292E+02,-1.9629,
     # 8.5734E+02,-2.1027,
     # 2.0702E+02,-1.5199,
     # 3.0197E+03,-2.4811,
     # 1.5653E+03,-2.4537,
     # 1.6850E+04,-3.4299 /
      end

